// HttpViewDlg.cpp : implementation file
//

#include "stdafx.h"
#include "HttpView.h"
#include "HttpViewDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CHttpViewDlg dialog

CHttpViewDlg::CHttpViewDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CHttpViewDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CHttpViewDlg)
	m_UrlAddress = _T("");
	m_View = _T("");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CHttpViewDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CHttpViewDlg)
	DDX_Text(pDX, IDC_EDIT_URL_ADDRESS, m_UrlAddress);
	DDX_Text(pDX, IDC_EDIT_VIEW, m_View);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CHttpViewDlg, CDialog)
	//{{AFX_MSG_MAP(CHttpViewDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON_GET, OnButtonGet)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CHttpViewDlg message handlers

BOOL CHttpViewDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
   //=========================================================



   //=========================================================
   // Выбираем адрес сервера FTP, который используется по 
   // умолчанию
   //=========================================================

   //://saturn
   m_UrlAddress = "http://saturn/frolov-cgi/test.bat?param1"; 
	//m_UrlAddress = "http://saturn/frlogo.gif"; 
   // Отображаем адрес на экране
   UpdateData(FALSE);

   //=========================================================
   // Инициализируем сеанс связи с Internet
   //=========================================================

   // Создаем сеанс связи с Internet, указываем в качестве 
   // имени программы-клиента название приложения FtpView
   m_InternetSession = new CInternetSession("FtpView");

   // В случае ошибки отображаем сообщение и завершаем 
   // приложение
   if(!m_InternetSession)
   {
      AfxMessageBox("New Session Error", MB_OK);
      OnOK();
   }
   // Инициализируем указатель m_FtpConnection
   m_HttpConnection = NULL;
	

	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CHttpViewDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CHttpViewDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

CHttpViewDlg::~CHttpViewDlg()
{
  // Если соединение с сервером FTP установлено, закрываем его
   if (m_HttpConnection != NULL)
   {
      m_HttpConnection -> Close();
      delete m_HttpConnection;
   }
   // Завершаем сеанс связи с Internet
   if (m_InternetSession != NULL)
   {
      m_InternetSession -> Close();
      delete m_InternetSession;
   }
}

void CHttpViewDlg::OnButtonGet() 
{

   // Если вы ранее уже соединились с сервером FTP, разрываем 
   // эту связь и удаляем объект m_FtpConnection
   if (m_HttpConnection != NULL)
   {
      m_HttpConnection -> Close();
      
      delete m_HttpConnection ;   
      m_HttpConnection = NULL;
   }

   // Считываем из диалоговой панели адрес сервера FTP, так 
   // как пользователь мог его уже изменить
   UpdateData(TRUE);


	m_View = "";
	// Отображаем адрес на экране
	UpdateData(FALSE);


	CString sServer;
	CString sObject;
	INTERNET_PORT nPort;
	DWORD dwServiceType;
	

	if (!AfxParseURL(m_UrlAddress, dwServiceType, sServer, sObject, nPort))
	{
		AfxMessageBox("AfxParseURL Error");
		
		return;
	}

	if(dwServiceType != AFX_INET_SERVICE_HTTP)
	{
		AfxMessageBox("URL Address not WWW server");
			
		return;
	}


	CHttpFile* pFile=NULL;	

	try
	{
		m_HttpConnection = m_InternetSession -> GetHttpConnection( sServer );


		pFile = m_HttpConnection -> OpenRequest(	CHttpConnection::HTTP_VERB_GET,
																sObject,
																NULL,
																1,
																NULL,
																NULL,
																INTERNET_FLAG_EXISTING_CONNECT
															);


		//CString headerInfo(_T("Accept: audio/*\r\n"));

		CString headerInfo(_T("Accept-Language: ru\r\n"));
		CString headerInfo2(_T("User-Agent: Tester\r\nAccept: text/html\r\n"));
		CString headerInfoRep(_T("Accept-Language: \r\n"));
	
		BOOL fSuccess;

		fSuccess = pFile->AddRequestHeaders(headerInfo);

		if(fSuccess = pFile->AddRequestHeaders(headerInfoRep,	HTTP_ADDREQ_FLAG_REPLACE))
				
		if(fSuccess = pFile->AddRequestHeaders(headerInfo2))
		{
			if(fSuccess = pFile->SendRequest())
			{
				DWORD dwReturnCode;

				if(fSuccess = pFile->QueryInfoStatusCode(dwReturnCode))
				{
					CString sMessage;

					sMessage.Format("%d",dwReturnCode);

					m_View += "======================================== Response Headers"
						       "========================================\r\n";

					m_View += "SendRequest = " + sMessage + "\r\n";

					pFile->QueryInfo( HTTP_QUERY_STATUS_TEXT, sMessage, NULL);
					m_View += "HTTP_QUERY_STATUS_TEXT = " + sMessage + "\r\n";

					pFile->QueryInfo( HTTP_QUERY_CONTENT_TYPE, sMessage, NULL);
					m_View += "HTTP_QUERY_CONTENT_TYPE = " + sMessage + "\r\n";

					pFile->QueryInfo( HTTP_QUERY_CONTENT_LENGTH, sMessage, NULL);
					m_View += "HTTP_QUERY_CONTENT_LENGTH = " + sMessage + "\r\n";

					pFile->QueryInfo( HTTP_QUERY_LAST_MODIFIED, sMessage, NULL);
					m_View += "HTTP_QUERY_LAST_MODIFIED = " + sMessage + "\r\n";

					pFile->QueryInfo( HTTP_QUERY_DATE, sMessage, NULL);
					m_View += "HTTP_QUERY_DATE = " + sMessage + "\r\n";

					m_View += "======================================== Response Data"
						       "========================================\r\n";
				}
				else
				{
					AfxMessageBox("Request Error");
				}
			}
		}
	
	}

	catch (CInternetException* pEx)
	{
		// Обрабатываем исключение CInternetException
		TCHAR szErr[1024];  // временный буфер для сообщения

		// Выводим сообщение об ошибке
		if (pEx->GetErrorMessage(szErr, 1024))
			AfxMessageBox( szErr );

		// Удаляем иссключение
		pEx->Delete();
	}
	pFile->SetReadBufferSize(2000);

	
	CString sTotal;

	CString sStringTemp;

	while (pFile->ReadString(sStringTemp))
	{
		m_View += sStringTemp + "\r\n";
	}

		// Отображаем адрес на экране
		UpdateData(FALSE);
   		
	pFile->Close();
	if(pFile)
		delete pFile;
}

